package dev.shadowsoffire.apotheosis.mixin;

import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.LivingEntity;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.CrescendoEnchant;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.InteractionResultHolder;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.Item;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Pseudo;
import net.minecraft.world.item.CrossbowItem;

@Pseudo
@Mixin(targets = { "com.hollingsworth.arsnouveau.common.items.SpellCrossbow" })
public class SpellCrossbowMixin extends CrossbowItem
{
    public SpellCrossbowMixin(final Item.Properties pProperties) {
        super(pProperties);
    }
    
    @Inject(method = { "m_7203_" }, at = { @At(value = "INVOKE", target = "Lcom/hollingsworth/arsnouveau/common/items/SpellCrossbow;shootStoredProjectiles(Lnet/minecraft/world/level/Level;Lnet/minecraft/world/entity/LivingEntity;Lnet/minecraft/world/InteractionHand;Lnet/minecraft/world/item/ItemStack;FF)V", remap = false) })
    public void apoth_preFired(final Level pLevel, final Player pPlayer, final InteractionHand pHand, final CallbackInfoReturnable<InteractionResultHolder<ItemStack>> ci) {
        CrescendoEnchant.preArrowFired(pPlayer.m_21120_(pHand));
    }
    
    @Inject(method = { "m_7203_" }, at = { @At(value = "RETURN", ordinal = 0) })
    public void apoth_addCharges(final Level pLevel, final Player pPlayer, final InteractionHand pHand, final CallbackInfoReturnable<InteractionResultHolder<ItemStack>> ci) {
        CrescendoEnchant.onArrowFired(pPlayer.m_21120_(pHand));
    }
    
    @Inject(method = { "getArrow" }, at = { @At("RETURN") }, remap = false)
    private void apoth_markArrows(final Level pLevel, final LivingEntity pLivingEntity, final ItemStack pCrossbowStack, final ItemStack pAmmoStack, final CallbackInfoReturnable<AbstractArrow> ci) {
        CrescendoEnchant.markGeneratedArrows((Projectile)ci.getReturnValue(), pCrossbowStack);
    }
}
